public class CarB extends Vehicle implements Runnable {

    private String nrRej;
    private int tankCapacity;   // pojemno baku
    private int fuel;           // ile jest paliwa?

    public CarB(String nr, Person owner, int w, int h, int l,
               int weight, int tankCap)  {
        super(owner, w, h, l, weight);
        nrRej = nr;
        tankCapacity = tankCap;
    }

    // Napenianie baku
    public void fill(int amount)  {
      fuel += amount;
      if (fuel > tankCapacity) fuel = tankCapacity;
    }

    // Start samochodu
    public void start()  {
      if (fuel > 0)   {
          super.start();
          new Thread(this).start();  // uruchamiamy wtek zuycia paliwa
      }
      else System.out.println("Brak paliwa");
    }

    // Zatrzymanie samochodu
    public void stop()  {
        super.stop();
    }

    public void run()  {
      while(getState() == MOVING) {
        try {
          Thread.sleep(1000);
        } catch(InterruptedException exc) { return; }
        fuel--;
        System.out.println("Paliwo: " + fuel);  // ledzimy ile jest paliwa
        if (fuel <= 0) stop();    // jeeli brak paliwa...zatrzymujemy samochd
      }
    }
 
    public String toString()  {
       return "Samochd nr rej " + nrRej + " - " + getState(getState());
    }
}